#!/usr/bin/env ruby

require "getoptlong"


$nice_command = "nice"
$nice_option = "-n "

Config = {
  "worker"		=> 4,
  "nice"		=> 5,
}

GetoptLong.new(*[
  ["--worker", "-w", GetoptLong::REQUIRED_ARGUMENT],
  ["--nice", "-n", GetoptLong::REQUIRED_ARGUMENT],
]).each {|opt, val| Config[opt.sub(/^--/, "")] = val}

worker = Integer(Config["worker"])
nice = Integer(Config["nice"])


def niced_job(nice, job)
  "#{$nice_command} #{$nice_option}#{nice} #{job}"
end


jobs = ARGF.readlines.collect {|line| line.chomp}
jobs.slice!(0, worker).each {|job| fork {exec niced_job(nice, job)}}

while not jobs.empty?
  begin
    Process.wait
    job = jobs.shift
    fork {exec niced_job(nice, job)}
  rescue
    # no children left or somthing.
  end
end

Process.waitall
